#include <cstdlib>
#include <ctime>
#include <iostream>
//
//
//
unsigned int selectRandomNumber(unsigned int x)
{
	// this is a stream so i can observe just the current x
	// and have no memory for previous ones

	static int count = 0;   // but I can count them  
	static int res;

	count++;                // another symbol seen so far

	if (count == 1)         // first call, we have just an number
		return x;
	else                    // second or next calls
	{
		unsigned int i = rand () % count; // generate a random number in [0....count]
		if (i == count-1)         // probability to select x is now 1/count
		{
			res = x;
		}
	}
	return res;

	// element n-th is picked with probability 1/count
	//
	// what about element n-1?
	//
	//  at previous step it had a chance to replace previous element with prob: 1/(count-1)
	//  at current step it has a probability to NOT being replaced of (count -1) / count
	//
	//  so the probability of BEING select is  [1/(count -1)]  * [(count -1)/count]
}

//
// driver program, select the random number in the stream of size i (element seen so far)
//
int main()
{
	int stream[] = {1, 2, 10, 30, 40, -1, -10, 10, 4};
	unsigned int sizeStream = sizeof(stream) / sizeof(stream[0]);
	int r;

	srand(time(NULL));                         // different seed for each run
	for (unsigned int i=0; i<sizeStream; ++i)  // size of stream seen so far
	{
		r = selectRandomNumber(stream[i]);
		std::cout << "Selected number " << r << " for position=" << i << std::endl;
	}

	int i;
	std::cin >> i;
}